my $ChooseBest = 0;

foreach (@ARGV) {
	if (/^-\?$/) {
		print <<_USAGE;
USAGE: $0 [-?|-b]

If no keys specified, all files with "BD" extension in the current dir will be processed and saved as .txt files

Keys:

? - shows this help screen
b - everywhere choose only da best answer
_USAGE
		close STDOUT;
		exit 0;
	}
	elsif (/^-b$/) {
		$ChooseBest = 1;
	}
}

close STDOUT;

opendir (DH, '.');
@fls = readdir DH;
closedir DH;

foreach (@fls) {
	&convert ($_) if (/\.BD$/);
}

sub convert {
	my $file = shift;
	open FH, $file;
	my @que = <FH>;
	close FH;
	my $c1 = 1;
	(my $out_file = $file) =~ s/\..+$//;
	open FH, ">$out_file.txt" or die "Error creating output file: $!\n";
	print FH "***Source file: $file***\n";
	print FH "***BEST ANSWER MODE IS ON***\n" if $ChooseBest;
	print FH "\n";
	foreach (@que) {
		if (/^wp\(\d+\s*,\s*(\d)+\s*,\s*"(\S+\d+)"\s*,\s*(.+)$/) {
			my ($quest_nr, $quest_id) = ($1, $2);
			(my $qa = $3) =~ s/\)\s*$//;
			$qa =~ s/\t/\n/g;
			$qa =~ s/^"//;
			$qa =~ s/"$//;
			$qa =~ s/\s\?/\?/g;
			$qa =~ s/\s,/,/g;
			$qa =~ s/\s+/\s/g;
			my @qa = split /"\s*,\s*"/, $qa;
			my $QU = &heh (shift @qa);
			$QU =~ s/t/ /g;
			print FH "<$quest_id($quest_nr): ", $QU, ">\n\n";
			my @q = splice @qa, 0, ($#qa + 1) / 2;
			my $c2 = 1;
			my @best = (0, '');
			foreach my $q (@q) {
				my $cor = &heh ($q);
				$cor =~ s/t/\n\t/g;
				if ($ChooseBest) {
					if ($qa[$c2 - 1] > $best[0]) {
						$best[0] = $qa[$c2 - 1];
						$best[1] = $cor;
					}
					if ($c2 == @q) {
						print FH "\t", $best[1], " W: $best[0]\n";
					}
				}
				else {
					print FH "A$c2:\t", $cor, " W: $qa[$c2 - 1]\n";
				}
				$c2 ++;
			}
			print FH "\n";
		}
		else {
			$c1 --;
		}
		$c1 ++;
	}
	close FH;
}

sub heh {
	my $str = shift;

	$str =~ s/(\S)/chr ((ord $1) + 1)/ge;
	return $str;
}